/*****************************************************************************
 *	axppi02s.c
 *
 *	AXP-PI02
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#define	STRICT
#include	<windows.h>
#include	<tchar.h>
#include	"axppi02w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szPI02[] = _T("AXP-PI02");
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSocket);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;						// 
	WORD  wLogSocket;					// foCXi[
	BYTE  Value;
	PI02_RESOURCE ri;					// \[X

//-----------------	 axppi02.dll ̎gp錾 --------------------------------
	if (Pi02wDllOpen() == FALSE) {
		ErrorMessage(PI02_SOCKET_AUTO);
		return 1;			// axppi02.dll ̃[hɎs܂
	}
//--------------------	o[Wԍ\	----------------------------------
	// AXP-PI02 DLL,Driver̃o[Wԍ擾
	if (Pi02wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(PI02_SOCKET_AUTO);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("GetVersion\n")
							_T("DLL Version: %08lxh\n")
							_T("Drv Version: %08lxh"), 
							dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
//-----------------------  AXP-PI02̎gp錾	 -----------------------------
	wLogSocket = PI02_SOCKET_AUTO;			// gp̃foCXT܂B
	bResult = Pi02wCreate( &wLogSocket, NULL, 0, NULL );
				// wLogSlot -- ꍇA̎̃foCXi[܂B
	if (bResult == FALSE) {
		ErrorMessage(PI02_SOCKET_AUTO);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("AXP-PI02 Created\n\n")
							_T("LogSocket: %2d\n"), 
							wLogSocket);
	ResultMessage(szbuf);
//-------------------------  \[X擾  -----------------------------
	if (Pi02wGetResource(wLogSocket, &ri) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("Card Name: %s\n")
							_T("IO Address 1: %04xh-%04xh\n")
							_T("IO Address 2: %04xh-%04xh\n") ,
							szPI02,
							ri.dwIOPortBase[0],ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
							ri.dwIOPortBase[1],ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1 );
	ResultMessage(szbuf);
//---------------------------  샂[h̐ݒ  -----------------------------
// |[g`		ڂ́A戵
// |[ga	o	ut^A. 샂[hꗗv
// |[gb	o	QƂB

	// fBNV 15H 
	if (Pi02wSetDirection(wLogSocket,0x15) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	// R}h|[g 90H 
	if (Pi02wOutPort(wLogSocket,PI02_PORT_CMD,0x90) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	// fBNV 39H 
	if (Pi02wSetDirection(wLogSocket,0x39) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	// fBNV 28H 
	if (Pi02wSetDirection(wLogSocket,0x28) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("샂[hݒ肵܂\n")
							_T("|[g`@\n" )
							_T("|[ga@o\n" )
							_T("|[gb@o\n" ));
	ResultMessage(szbuf);

//---------------------------  o͎s  -----------------------------

	if (Pi02wOutPort(wLogSocket,PI02_PORT_B,0xAA) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("|[ga AAh o͂܂\n") );
	ResultMessage(szbuf);

//---------------------------  ͎s  -----------------------------

	Value = (BYTE)0x00;
	if (Pi02wInPort(wLogSocket,PI02_PORT_A,&Value) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	_stprintf_s(szbuf, 256, _T("͒l |[g` %X h\n"), Value );
	ResultMessage(szbuf);

//-------------------  AXP-PI02̎gpJ	 -------------------------------
	if (Pi02wClose(wLogSocket) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage(_T("AXP-PI02 Closed"));

//----------------------  axppi02.dll ̎gpJ  ----------------------------
	if (Pi02wDllClose() == FALSE) {
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"),
										szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// axppi02.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSocket)
{
	DWORD dwRes = Pi02wGetLastError(wLogSocket);
	TCHAR szbuf[50];

	switch (dwRes) {
		case PI02_ERR_SYSTEM:
			_stprintf_s(szbuf, 50, _T("System error\n\n")
								   _T("Error code: %08lxh"),
								   GetLastError());
			break;

		case AXPPI02_ERR_WRAPDLL:
			_stprintf_s(szbuf, 50, _T("DLL Load error"));
			break;

		default:
			_stprintf_s(szbuf, 50, _T("AXP-PI02 error\n\n")
								   _T("Error code: %08lxh"), 
								   dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}





